unit repunit;
{----------------------------------------------------------------------------

   Using the AbstractTable. Three fields have been set up
   using the object inspector

   Name : string
   Balance : Currency
   CustCode : integer;

 (c) 2005/2005 QBS Software
----------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, QRCtrls, QuickRpt, DB, QRAbsDatas, ExtCtrls;

type
  TrepForm = class(TForm)
    QuickRep1: TQuickRep;
    QRAbsTable1: TQRAbsTable;
    PageHeaderBand1: TQRBand;
    DetailBand1: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRLabel1: TQRLabel;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    procedure QRAbsTable1AfterScroll(DataSet: TDataSet);
    procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;
      var PrintReport: Boolean);
    procedure QRAbsTable1GetRecord(Sender: TQRAbsTable;
      var Moredata: Boolean);
    procedure QRAbsTable1SetFieldValue(const DataStr: String;
      Field: TField; buffer: Pointer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  repForm: TrepForm;
  recnum : integer;

implementation

{$R *.dfm}


procedure TrepForm.QRAbsTable1AfterScroll(DataSet: TDataSet);
begin
       // this is the correct place to increment the record number
       // if one is being used. This event is called after a 'movenext'
       inc( recnum);
end;

procedure TrepForm.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  var PrintReport: Boolean);
begin
       self.QRAbsTable1.Open;
       recNum := 0;
end;

procedure TrepForm.QRAbsTable1GetRecord(Sender: TQRAbsTable;
  var Moredata: Boolean);
begin
      moredata := recnum < 100;
      inc(recnum);
end;

procedure TrepForm.QRAbsTable1SetFieldValue(const DataStr: String; Field: TField; buffer: Pointer);
var
    strval : string;
    cval : double;
    ival : integer;
    dateval : TDatetime;
begin
      // This example shows how to put values in the field buffer.
      // Be aware this event is called once for every field, for each record
      // Here one may use datasets or any other means to get data or the fields.
      strval := 'Name ' + inttostr(recnum);
      if Field.FieldName = 'Name' then
           strpcopy( pchar(buffer), strval );
      cval := 107.37 * recnum;
      if Field.FieldName = 'Balance' then
                     Move( cval, Buffer^, Field.DataSize);
      ival := recnum + 5000;
      if Field.FieldName = 'CustCode' then
               Move( ival, Buffer^, Field.DataSize);

      dateval := date;
      if Field.FieldName = 'InvoiceDate' then
               Move( dateval, Buffer^, Field.DataSize);

end;

end.
